#import <simtools.h>
#import <defobj/Create.h>
#import <collections.h>

@interface Voter1: CreateDrop
{
  double Issue1;
  double Issue2;
  double Issue3;
  double Issue4;
}
- (void)describe: stream;
@end

@implementation Voter1
- (void)describe: stream
{
  [stream catC: "Issue1: "];
  [stream catDouble: Issue1];
  [stream catC: " Issue2: "];
  [stream catDouble: Issue2];
  [stream catC: " Issue3: "];
  [stream catDouble: Issue3];
  [stream catC: " Issue4: "];
  [stream catDouble: Issue4];
  [stream catC: "\n"];
}
@end

@interface Voter2: CreateDrop
{
  double Race;
  double Pref;
  double Housing;
  double Income;
  double LocX;
  double LocY;
}
- (void)describe: stream;
@end

@implementation Voter2
- (void)describe: stream
{
  [stream catC: "Race: "];
  [stream catDouble: Race];
  [stream catC: " Pref: "];
  [stream catDouble: Pref];
  [stream catC: " Housing: "];
  [stream catDouble: Housing];
  [stream catC: " Income: "];
  [stream catDouble: Income];
  [stream catC: " LocX: "];
  [stream catDouble: LocX];
  [stream catC: " LocY: "];
  [stream catDouble: LocY];
  [stream catC: "\n"];
}
@end

static void
printMap (id <Map> map, id <OutputStream> stream)
{
  id <MapIndex> mi = [map mapBegin: scratchZone];
  id <String> name;
  id member;

  for (member = [mi next: (id *) &name];
       [mi getLoc] == Member;
       member = [mi next: (id *) &name])
    {
      [stream catC: [name getC]];
      [stream catC: ": "];
      [member describe: stream];
    }
}

int
main (int argc, const char **argv)
{
  initSwarm (argc, argv);
 
  {
    id <OutputStream> stream = [[[OutputStream createBegin: globalZone]
                                  setFileStream: stdout]
                                 createEnd];

    printMap ([hdf5AppArchiver getObject: "map1"], stream);
    printMap ([hdf5AppArchiver getObject: "map2"], stream);
  }
  return 0;
}

/*
Local Variables:
compile-command: "$SWARMHOME/bin/libtool-swarm --mode=link gcc -DAPPNAME=voting -o voting -Wall -Werror -g -Wno-import -I$SWARMHOME/include/swarm -L$SWARMHOME/lib/swarm voting.m -lswarm -lobjc"
End:
*/
